var bug_userid = 0;
var bug_statusData = [];
var bug_httpRequests = [];
var bug_urls = [];
var bug_pages = [];
var bug_prefmanager = null;

// **** Generic Utility Functios
function bug_getPrefManager() {
	if (bug_prefmanager) {
		return bug_prefmanager;
	}
	else {
		return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	}
}
function bug_getPref(named) {
	return bug_getPrefManager().getCharPref(named);
}
function bug_setPref(named, value) {
	return bug_getPrefManager().setCharPref(named, value);
}
function bug_getIntPref(named) {
	return bug_getPrefManager().getIntPref(named);
}
function bug_setIntPref(named, value) {
	return bug_getPrefManager().setIntPref(named, value);
}
function bug_getBoolPref(named) {
	return bug_getPrefManager().getBoolPref(named);
}
function bug_setBoolPref(named, value) {
	return bug_getPrefManager().setBoolPref(named, value);
}
function bug_getTimeStamp() {
	return Math.round(new Date().getTime()/1000.0);
}
function bug_openNewTab(url, postData) {
	var tBrowser = top.document.getElementById("content");
	var tab = tBrowser.addTab("about:blank");
	tBrowser.selectedTab = tab;
	tBrowser.getBrowserForTab(tab).webNavigation.loadURI(url, 0, null, postData, null);            
}

function bgetId(name){
	var x = top.document.getElementById(name);
	return x;
}

// simple AJAX handler
function bug_startRequest(url, callback) {
   var http_request = false;
   http_request = new XMLHttpRequest();
   if (http_request.overrideMimeType) {
      http_request.overrideMimeType('text/xml');
   }
   if (!http_request) {
      alert('Cannot create XMLHTTP instance');
      return false;
   }
   if (callback) {
      http_request.onreadystatechange = callback;
   }
   http_request.open('GET', url, true);
   http_request.send(null);
   return http_request;
}
function bug_buildPostData(dataString) {
	// POST method requests must wrap the encoded text in a MIME
	// stream
	Cc = Components.classes;
	Ci = Components.interfaces;
	var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
	                   createInstance(Ci.nsIStringInputStream);
	stringStream.setData(dataString, dataString.length);
	
	var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
	               createInstance(Ci.nsIMIMEInputStream);
	postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
	postData.addContentLength = true;
	postData.setData(stringStream);
	return postData;
}

// Globals to handle some of our most common UI strings;
var bug_stringsBundle;
function btext(named) {
	var oo = bug_stringsBundle.getString(named);
	return oo;
}
function bug_getStringTable() {
	 bug_stringsBundle = top.document.getElementById("bug_string_bundle");
}
// format the text
function bftext(aName, aParams) {
  return bug_stringsBundle.getFormattedString(aName, aParams);
}
function bug_buildUrl(controller, param1, param2)
{
	var site = bug_getPref("extensions.buggd.defaultSearchPage");
	return 'http://' + site + "/" + controller + "/" + (param1 ? param1 : '') + (param2 ? "/" + param2 : '');
}

function bug_httpGood(request)
{
  return (request && request.readyState == 4 && request.status == 200);
}

function bug_buildEmailUrl() {
	var email = bug_getPref("extensions.buggd.emailAddress");
	var text = bug_buildUrl('sdk/user_emailhash', bug_getHashString(email));
	return text;	
}


// Function for putting together the user's URLs to interact with bug.gd
function bug_buildUrls() {
	//bug_urls["userid"] = bug_buildEmailUrl();

	bug_urls.rank = bug_buildUrl('sdk/errortotal_rank', bug_userid);
	bug_urls.solved = bug_buildUrl('sdk/user_solvederrors', bug_userid);
	bug_urls.unsolved = bug_buildUrl('sdk/user_unsolvederrors', bug_userid);
	bug_urls.rating = bug_buildUrl('sdk/user_rating', bug_userid);
	bug_urls.comments = bug_buildUrl('sdk/comments', bug_userid, "0");
	bug_urls.lasterror = bug_buildUrl('sdk/last_error', bug_userid);
	bug_urls.lastunsolved = bug_buildUrl('sdk/last_unsolved_error', bug_userid);
}

// Function for putting together the user's help pages to interact with bug.gd
function bug_buildPages() {
	//bug_urls["userid"] = bug_buildEmailUrl();

	bug_pages.main = bug_buildUrl('');
	bug_pages.refer = bug_buildUrl('search/refer');
	bug_pages.news = "http://blog.bug.gd";
	bug_pages.about = bug_buildUrl('search/about');
	bug_pages.faq = bug_buildUrl('search/faq');
	bug_pages.mybugs = bug_buildUrl('search/recentsearch');
}
function bug_changeStatusLabel(text) {
	bgetId('buggd_panel').label = text;
}
// main function for refreshing the status label
function bug_updateStatusLabel() {
	// update label now
	if (bug_userid) {
		var unsolved = parseInt(bug_statusData.unsolved,10);
		var solved = parseInt(bug_statusData.solved,10);
		if (unsolved > 0) {
			 bug_changeStatusLabel(bftext("unsolved_suffix", [unsolved]));
		}
		else if (solved > 0) {
			bug_changeStatusLabel(bftext("solved_suffix", [solved]));
		}
		else {
			bug_changeStatusLabel(btext("nobugs"));
		}
	}
	else {
		bug_changeStatusLabel(btext("needusername"));
	}
}


// everything appears to be ready to go-- update!
var bug_suppresspopup = false;
function bug_allStatusReceived() {
	bug_updateStatusLabel();
	var lasttime = bug_getIntPref('extensions.buggd.lastReminder');
	var now = bug_getTimeStamp();
	var allowed = bug_getBoolPref('extensions.buggd.reminderOnLoad');
	if (!bug_suppresspopup && allowed && now-lasttime > 86400 && bug_statusData.lastunsolved)  {
		bug_showErrorTextPopup(bgetId('buggd_panel'));
		bug_setIntPref('extensions.buggd.lastReminder', now);	
	}
	if (bug_statusData.lastunsolved) {
		bug_suppresspopup = true;
	}
}


// trying to make a custom status function for each one
function bug_getSetStatusFunction(name) {
	var foo = function () { 
		if (bug_httpGood(bug_httpRequests[name])) {
			bug_statusData[name] = bug_httpRequests[name].responseText;
		}
		for (var x in bug_httpRequests)
		{
			if (!bug_httpGood(bug_httpRequests[x]))
			{
				return;
			}
		}
		bug_allStatusReceived();
	};
	return foo;
}

function bug_doStatusAjax(name, url) {
	bug_httpRequests[name]= bug_startRequest(url, bug_getSetStatusFunction(name));	
}

var bug_user_request = 0;
function bug_do_getUserid() {
	bug_user_request = bug_startRequest(bug_buildEmailUrl(), bug_getUserid);
}

function bug_touchServerEmailDate(userid) {
	bug_startRequest(bug_buildUrl("sdk/updateemaildate", bug_userid), null);
}
function bug_getInitialValues() {
		bug_changeStatusLabel(btext("loading"));
	
		if (bug_userid) {
			bug_buildUrls();
			for (var x in bug_urls) {
				if (typeof(bug_urls[x])=="string") {
					bug_doStatusAjax(x, bug_urls[x]);
				}
			}
			// update last email date
			bug_touchServerEmailDate(bug_userid);
		}
		else
		{
			bug_do_getUserid();
		}
}

function bug_isEmailProvided() {
	var email = bug_getPref("extensions.buggd.emailAddress");
	return (email && email.length > 3);
}

var bug_triedtocreate = false;
function bug_getUserid() {
	if (bug_httpGood(bug_user_request)) {
		var data = bug_user_request.responseText; 
		bug_userid = parseInt(data,10);
		bug_updateStatusLabel();
	}
	// first time initialization is good
	if (bug_userid) {
		bug_getInitialValues();
	}
}

function bug_newUser() {
	bug_openNewTab(bug_buildUrl('search/newuser'));
} 

var bug_email_request = 0;
function bug_do_getEmail(func) {
	bug_email_request = null;
	bug_email_request = bug_startRequest(bug_buildUrl('sdk/getemailfromcookie'), func);
}
function bug_getEmailFirst() {
	if (bug_httpGood(bug_email_request)) {
		var bug_email = bug_email_request.responseText;
		if (bug_email.length > 3)  {
			bug_setPref("extensions.buggd.emailAddress", bug_email);
			bug_do_getUserid();
		}
		else
		{
			bug_newUser();
			bug_updateStatusLabel();			
		}
	}
}
function bug_getEmail() {
	if (bug_httpGood(bug_email_request)) {
		var bug_email = bug_email_request.responseText;
		if (bug_email.length > 3)  {
			bug_setPref("extensions.buggd.emailAddress", bug_email);
			bug_do_getUserid();
		}
	}
}

function bug_getEmailGet() {
	var email = bug_getPref("extensions.buggd.emailAddress");
	return "email=" + email;
}
function bug_buildEmailPost() {
	return bug_buildPostData(bug_getEmailGet());
}

function bug_refreshButtonLabels() {
    try
    {
		bug_getInitialValues();
		bug_openNewTab(bug_buildUrl('search/recentsearch',''), bug_buildEmailPost());
    }
    catch(e)
    {
            alert(e);
    }
}

function bug_hideErrorTextPopup()
{
	bgetId('buggd_popup').hidePopup();
	window.removeEventListener("click", bug_hideErrorTextPopup, false);
}

function bug_addPopupHideOnClickHandler() {
	window.addEventListener('click', bug_hideErrorTextPopup, false);
}
function bug_showErrorTextPopup(elem)
{
	var mylabel = bug_statusData.lastunsolved;
	if (mylabel.length > 60) 
	{
		mylabel = bug_statusData.lastunsolved.substring(0,60)+"...";
	}
	bgetId('buggd_popup_error_text').value=mylabel;
	bgetId("buggd_popup").showPopup(elem,  -1, -1, 'popup', 'topright' , 'bottomright');
	setTimeout(bgetId('buggd_popup').hidePopup,10000);
	setTimeout(bug_addPopupHideOnClickHandler,1000);
}

function bug_buttonClicked(elem, event)
{
	if(event.button == 0) {
		if (!bug_userid) {
			var email = bug_getPref("extensions.buggd.emailAddress");
			if (!email || email.length < 3) {
				bug_do_getEmail(bug_getEmailFirst);	
			}
			else {
				bug_do_getUserid();	
			}			
		}
		else {
			bug_openSearchWindow();
		}
	}
}

function bug_popupClicked(elem, event)
{
		bug_openNewTab(bug_buildUrl('search/recentsearch',''), bug_buildEmailPost());
}

function bug_tooltipPopulateByName(name) {
	var tooly = bgetId('buggd_toolbar_tooltip_details_' + name);
	if (tooly) {
		tooly.value = bftext(name, [bug_statusData[name]]);
	} 
}
function bug_tooltipPopulate()
{
	try {
		var pp = bgetId('buggd_tooltip_header_text');
		pp.value = btext("header");
		if (bug_userid)
		{
			for (var area in bug_statusData) 
			{
				if (typeof(bug_statusData[area])=="string")
				{
					bug_tooltipPopulateByName(area);
				}
			}
			if (bug_statusData.lastunsolved)
			{
				bgetId('buggd_toolbar_tooltip_lowerbox').hidden = false;
				bgetId('buggd_toolbar_tooltip_details_lasterror_text').value = btext("mostrecent");
			}
			else
			{
				bgetId('buggd_toolbar_tooltip_lowerbox').hidden = true;
			}
		}
		else
		{
			bgetId('buggd_toolbar_tooltip_details_solved').value = btext("pleasesearch");
			bgetId('buggd_toolbar_tooltip_details_comments').value = btext("pleasesearch2");
			bgetId('buggd_toolbar_tooltip_lowerbox').hidden = true;
		}
	}
	catch (e)
	{
		alert(e);
	}	
}

// These functions handle the search popup window
function bug_openSearchWindow()
{
	var retVals = { text: null};	
    window.openDialog('chrome://buggd/content/searchwindow.xul', '', 'chrome,dialog=0,modal=1,resizable=1', retVals);
	if (retVals.text)
	{
		bug_doSearch(retVals.text);
	}
}
function bug_debugPref(prefname, func) {
	return "\n" + prefname + " = " + func(prefname);
}
function bug_debugLine(value, named) {
	return "\n" + named + ' = ' + value;
}
function bug_openDebugWindow()
{
	var output = "";
	output += bug_debugLine(bug_userid, 'bug_userid');
	output += bug_debugLine(bug_user_request.status, 'bug_user_request.status');
	output += bug_debugLine(bug_email_request.status, 'bug_email_request.status');
	for (var x in bug_httpRequests)
	{
		output += bug_debugLine(bug_httpRequests[x].status, x + ".status");
	}	
	output += bug_debugPref('extensions.buggd.lastReminder', bug_getIntPref);
	output += bug_debugPref('extensions.buggd.reminderOnLoad', bug_getBoolPref);
	output += bug_debugPref("extensions.buggd.defaultSearchPage", bug_getPref);
	output += bug_debugPref("extensions.buggd.emailAddress", bug_getPref);
	output += bug_debugPref("extensions.buggd.defaultPollInterval", bug_getIntPref);
	output += bug_debugPref("extensions.buggd.debug", bug_getBoolPref);
	var retVals = { text: output};	
    window.openDialog('chrome://buggd/content/debugwindow.xul', '', 'chrome,dialog=0,modal=1,resizable=1', retVals);
}

function bug_doSearch(text)
{
	var email = bug_getPref("extensions.buggd.emailAddress");
	var site = bug_getPref("extensions.buggd.defaultSearchPage");
	bug_postBuggdSearch(site, email, text);
}
function bug_postBuggdSearch(site, email, errortext)
{

	var dataString = "email=" + email + "&error=" + escape(errortext);
	var postData = bug_buildPostData(dataString);
    try
    {
			var myUrl = site + "/search/results_ajax";
			bug_openNewTab(myUrl, postData);
			// we need to recheck the values soon so the guy can get his stats updated
			setTimeout(bug_getInitialValues, 3000);
			bug_suppresspopup = true;		
    }
    catch(e)
    {
            alert(e);
    }
}
// Fill the provided element with clipboard data and select-all.
function bug_fillTextboxWithClipboard(element) {
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
		 getService(Components.interfaces.nsIClipboard); 
	if (!clip) { return true; }
	var trans = Components.classes["@mozilla.org/widget/transferable;1"]. 
		createInstance(Components.interfaces.nsITransferable); 
	if (!trans) { return true; } 
	trans.addDataFlavor("text/unicode");
	clip.getData(trans,clip.kGlobalClipboard); 
	var str = {}; 
	var strLength = {}; 
	trans.getTransferData("text/unicode",str,strLength);
	if (str) { str = str.value.QueryInterface(Components.interfaces.nsISupportsString); } 
	if (str) { element.value = str.data.substring(0,strLength.value / 2); }
	element.select();
	return true;	
}
function bug_fillTextboxWithDebugData(me, element) {
	var output = 'Debug information:\n';
	output += me.arguments[0].text;
	//output += bug_user_request;
	element.value = output;	
}
function bug_openPage(elem, which) {
	bug_openNewTab(bug_pages[which]);
}

function bug_ToggleSuppressPopup(elem) {
	bug_setBoolPref('extensions.buggd.reminderOnLoad', !bug_getBoolPref('extensions.buggd.reminderOnLoad'));
}

function bug_menuShowing(elem) {
	bgetId('buggd.context.suppress.startup').setAttribute('checked',  bug_getBoolPref('extensions.buggd.reminderOnLoad'));
	var debug = bug_getBoolPref("extensions.buggd.debug");
	if (debug) {
		bgetId('buggd_debug_option').hidden = false;
	}
	else {
		bgetId('buggd_debug_option').hidden = true;
	}
}

// repeated for the lifetime of the plugin
var bug_repeats = 10;
// default sitename for checking for things
function bug_repeatCheck(noreschedule) {
	var interval = bug_getIntPref("extensions.buggd.defaultPollInterval");
	if (bug_userid <=0) {
		var email = bug_getPref("extensions.buggd.emailAddress");
		if (!email || email.length < 3) {
			bug_do_getEmail(bug_getEmail);	
		}
		else {
			bug_do_getUserid();	
		}
		if (!noreschedule) {
			bug_repeats+=2;
			var interval = bug_repeats * 1000;
			setTimeout(bug_repeatCheck, interval);
		}
	}
	else {
		bug_getInitialValues();
		if (!noreschedule) {
			setTimeout(bug_repeatCheck, interval);
		}
	}
}

// Core initialization routine
function bug_initialize() {
	if (!bug_stringsBundle) { bug_getStringTable(); }
	bug_sitename = bug_getPref("extensions.buggd.defaultSearchPage");
	if (bug_userid <= 0){
		var email = bug_getPref("extensions.buggd.emailAddress");
		if (!email || email.length < 3) {
			bug_do_getEmail(bug_getEmailFirst);	
		}
		else {
			bug_do_getUserid();	
		}
	}
	bug_buildPages();
	setTimeout(bug_repeatCheck, 10000);
    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent) {
      appcontent.addEventListener("DOMContentLoaded", bug_page_load, true);
    }
}

function bug_getHashString(target) {
	var converter =
	  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
	    createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	
	// we use UTF-8 here, you can choose other encodings.
	converter.charset = "UTF-8";
	// result is an out parameter,
	// result.value will contain the array length
	var result = {};
	// data is an array of bytes
	var data = converter.convertToByteArray(target, result);
	var ch = Components.classes["@mozilla.org/security/hash;1"]
	                   .createInstance(Components.interfaces.nsICryptoHash);
	ch.init(ch.MD5);
	ch.update(data, data.length);
	var hash = ch.finish(false);
	// return the two-digit hexadecimal code for a byte
	function toHexString(charCode)
	{
	  return ("0" + charCode.toString(16)).slice(-2);
	}
	// numerically loop through the hash because we know MD5 hashes are
	// always 16 bytes long. The real reason we don't use for (i in hash) is
	// because if someone overloads String like this:
	//     String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };
	// then what will happen is that the for loop will end with a "trim" index
	// which is clearly not part of the md5 hash. :P
	var qqqs = '';
	for (var i = 0;i<=15;i++)
	{
		qqqs += toHexString(hash.charCodeAt(i));
	}
	// convert the binary hash data to a hex string.
	//var qqqs = [toHexString(hash.charCodeAt(i)) for (i = 0;i<=15;i++)].join("");
	//alert(qqqs);
	return qqqs;
	// s now contains your hash in hex: should be
	// 5eb63bbbe01eeed093cb22bb8f5acdc3
}

function bug_toolbar_load() {
	bug_initialize();
}

function bug_window_load() {
	bug_initialize();
}

function bug_repeatCheck_true() {
			bug_repeatCheck(true);
}
var bug_lastfire = 0;
function bug_page_load(event) {
	var bug_sitename = '';
	bug_sitename = bug_getPref("extensions.buggd.defaultSearchPage");    
	var doc = event.originalTarget;
    if(doc.location.href.search(bug_sitename) > -1)
    {
		var now = bug_getTimeStamp();
		// require 10 seconds before we'll allow another update to fire
		if (now - bug_lastfire > 10) 
		{
			bug_lastfire = now;
			setTimeout(bug_repeatCheck_true, 500);
		}
    }
}

